#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t, n, k;
    cin>>t>>n>>k;
    vector <int> niz(n);
    for (int i=0; i<n; i++)
    {
        cin>>niz[i];
    }
    sort (niz.begin(), niz.end());
    int ans=0;
    for (int i=0; i<n; i++)
    {
        if (niz[i]>=ans) ans++;
        else ans--;
    }
    if (ans==k)
    {
        cout<<"DA"<<endl;
        for (int i=0; i<n; i++) cout<<niz[i]<<" ";
        cout<<endl;
    }
    else cout<<"NE"<<endl;
    return 0;
}